"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Config {
    constructor(raw) {
        this.raw = raw;
    }
    /**
     * set an extension config to the registry.
     * @param id extension id
     * @param config plain config object
     */
    set(id, config) {
        this.raw.set(id, config);
    }
    /**
     * get a config entry
     * @param id extension id.
     */
    get(id) {
        return this.raw.get(id);
    }
    /**
     * instantiate from a plain config-like object.
     */
    static from(raw) {
        return new Config(new Map(Object.entries(raw)));
    }
}
exports.Config = Config;
