import { Graph } from 'cleargraph';
import { ExtensionManifest } from '../extension';
import { Extension } from '../extension';
export default class DependencyGraph extends Graph<Extension, string> {
    private cache;
    byExecutionOrder(): Extension[];
    execute(): void;
    add(manifest: ExtensionManifest): this;
    load(extensions: ExtensionManifest[]): this;
    getExtension(manifest: ExtensionManifest): Extension | null;
    get(id: string): any;
    /**
     * build Harmony from a single extension.
     */
    static fromRoot(extension: ExtensionManifest): DependencyGraph;
    /**
     * build Harmony from set of extensions
     */
    static from(extensions: ExtensionManifest[]): DependencyGraph;
}
