"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SlotRegistry {
    constructor(registerFn, map = new Map()) {
        this.registerFn = registerFn;
        this.map = map;
    }
    get(id) {
        return this.map.get(id);
    }
    toArray() {
        return Array.from(this.map.entries());
    }
    values() {
        return Array.from(this.map.values());
    }
    register(value) {
        const id = this.registerFn();
        this.map.set(id, value);
    }
}
exports.SlotRegistry = SlotRegistry;
