module.exports.Features = Object.freeze({
  name: 'name',
  description: 'description',
  keywords: 'keywords',
  model: 'model',
  slots: 'slots',
  props: 'props',
  data: 'data',
  computed: 'computed',
  events: 'events',
  methods: 'methods'
})

module.exports.Properties = Object.freeze({
  name: 'name',
  model: 'model',
  props: 'props',
  data: 'data',
  computed: 'computed',
  template: 'template',
  inheritAttrs: 'inheritAttrs',
  beforeRouteEnter: 'beforeRouteEnter',
  beforeRouteUpdate: 'beforeRouteUpdate',
  beforeRouteLeave: 'beforeRouteLeave',
  beforeCreate: 'beforeCreate',
  created: 'created',
  beforeMount: 'beforeMount',
  mounted: 'mounted',
  beforeUpdate: 'beforeUpdate',
  updated: 'updated',
  beforeDestroy: 'beforeDestroy',
  destroyed: 'destroyed',
  render: 'render',
  methods: 'methods'
})

module.exports.Syntax = Object.freeze({
  ClassExpression: 'ClassExpression',
  BinaryExpression: 'BinaryExpression',
  FunctionExpression: 'FunctionExpression',
  FunctionDeclaration: 'FunctionDeclaration',
  ImportDeclaration: 'ImportDeclaration',
  ClassDeclaration: 'ClassDeclaration',
  Super: 'Super',
  Literal: 'Literal',
  Identifier: 'Identifier',
  ArrayPattern: 'ArrayPattern',
  ArrayExpression: 'ArrayExpression',
  ObjectExpression: 'ObjectExpression',
  ArrowFunctionExpression: 'ArrowFunctionExpression',
  UnaryExpression: 'UnaryExpression',
  ReturnStatement: 'ReturnStatement',
  CallExpression: 'CallExpression',
  MemberExpression: 'MemberExpression',
  NewExpression: 'NewExpression',
  VariableDeclaration: 'VariableDeclaration',
  VariableDeclarator: 'VariableDeclarator',
  ExportAllDeclaration: 'ExportAllDeclaration',
  ExportNamedDeclaration: 'ExportNamedDeclaration',
  ExportDefaultDeclaration: 'ExportDefaultDeclaration',
  Property: 'Property',
  BlockStatement: 'BlockStatement',
  TemplateLiteral: 'TemplateLiteral',
  TaggedTemplateExpression: 'TaggedTemplateExpression',
  ThisExpression: 'ThisExpression',
  AssignmentPattern: 'AssignmentPattern',
  RestElement: 'RestElement',
  ObjectPattern: 'ObjectPattern',
  ExpressionStatement: 'ExpressionStatement',
  IfStatement: 'IfStatement',
  SwitchStatement: 'SwitchStatement',
  SwitchCase: 'SwitchCase',
  BreakStatement: 'BreakStatement',
  ContinueStatement: 'ContinueStatement',
  LabeledStatement: 'LabeledStatement',
  ThrowStatement: 'ThrowStatement',
  TryStatement: 'TryStatement',
  CatchClause: 'CatchClause',
  AssignmentExpression: 'AssignmentExpression',
  WhileStatement: 'WhileStatement',
  DoWhileStatement: 'DoWhileStatement',
  ForStatement: 'ForStatement',
  ForInStatement: 'ForInStatement',
  ForOfStatement: 'ForOfStatement',
  SpreadElement: 'SpreadElement'
})

module.exports.UNDEFINED = undefined
module.exports.DEFAULT_TYPE = 'any'
